routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::resource('posts', 'PostController');
Route::get('/', 'HomeController@index')
  ->middleware('auth')
  ->name('home');

app/Models/Post.php
<?php

namespace App\Models;

use Carbon\Carbon;
use App\Models\User;
use Illuminate\Support\Str;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    protected $fillable = [
        'user_id',
        'title',
        'content',
        'is_draft',
        'is_members_only',
        'posted_at'
    ];

    protected $casts = [
        'posted_at' => 'datetime' 
    ];

    public function scopeWithAuthorPosts($query)
    {
        return $query
            ->isDraft(0)
            ->orWhere('user_id', auth()->id(), function($query) {
                $query->isDraft(1);
            });
    }

    public function scopeIsDraft($query, $status)
    {
        return $query->where('is_draft', $status);
    }

    public function scopeIsMembersOnly($query, $status)
    {
        return $query->where('is_members_only', $status);
    }
    
    public function scopeIsNotFuturePosts($query)
    {
        return $query->where('posted_at', '<=', now());
    }

    public function scopePostsForAllUsers($query)
    {
        return $query
            ->isDraft(0)
            ->isMembersOnly(0)
            ->isNotFuturePosts();
    }

    public function scopePostsForLoggedInUsers($query)
    {
        return $query
            ->withAuthorPosts()
            ->isNotFuturePosts();
    }

    public function scopeShowAllPosts($query)
    {
        return $query->with('user')
            ->when(auth()->guest(), function ($query) {
                return $query->postsForAllUsers();
            })
            ->when(auth()->check(), function ($query) {
                return $query->postsForLoggedInUsers();
            })
            ->orderByDesc('posted_at');
    }

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function getUppercaseTitleAttribute()
    {
        return Str::upper($this->title);
    }

    public function getPostedDateAttribute()
    {
        return $this->posted_at->format('Y-m-d');
    }

    public function getUpdatedDateAttribute()
    {
        return $this->updated_at->format('Y-m-d');
    }

    public function getInputPostedAtAttribute()
    {
        return $this->posted_at->toDateTimeLocalString();
    }

    public function setPostedAtAttribute($value)
    {
        $this->attributes['posted_at'] = Carbon::parse($value)->format('Y-m-d H:i:s');
    }

    public function getContentWithBreakAttribute()
    {
        return nl2br($this->content, false);
    }
}

app/Models/User.php
<?php

namespace App\Models;

use App\Models\Post;
use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function posts()
    {
        return $this->hasMany(Post::class);
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

class HomeController extends Controller
{
    /**
     * Display a listing of the users' posts.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $posts = auth()->user()->posts()
            ->orderByDesc('posted_at')
            ->get();

        return view('home', compact('posts'));
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Models\Post;
use Illuminate\Http\Request;
use App\Http\Requests\PostRequest;
use Illuminate\Support\Facades\Auth;

class PostController extends Controller
{
    public function __construct() {    
        $this->middleware('auth')->except(['index', 'show']);
    }
    
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $posts = Post::query()
            ->showAllPosts()
            ->paginate(10);
        
        return view('posts.index', compact('posts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('posts.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PostRequest $request)
    {
        Post::create($request->all());

        return redirect()->route('home');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        return view('posts.show', compact('post'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function edit(Post $post)
    {
        $this->authorize('update', $post);

        return view('posts.edit', compact('post'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function update(PostRequest $request, Post $post)
    {
        $this->authorize('update', $post);

        $post->update($request->all());

        return redirect()->route('home');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function destroy(Post $post)
    {
        $this->authorize('delete', $post);

        $post->delete();

        return redirect()->back();
    }
}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                @auth
                    <div class="row">
                        <div class="col-6"><h3>Your Posts</h3></div>
                        @if($posts->isNotEmpty())
                            <div class="col-6">
                                <a href="{{ route('posts.create') }}" class="btn btn-primary btn-sm float-right">Add post</a>
                            </div>
                        @endif
                    </div>
                    @forelse ($posts as $post)
                        @component('posts.item', ['post' => $post])
                            <div>
                                @if($post->is_draft)
                                <span class="badge badge-secondary">Draft</span>
                                @endif
                                @if($post->posted_at <= now())
                                    <span class="badge badge-primary">Published</span>
                                @endif
                                @if($post->is_members_only)
                                    <span class="badge badge-success">Members Only</span>
                                @endif
                            </div>
                            <span>Posted: {{ $post->posted_date }}</span> / <span>Updated: {{ $post->updated_date }}</span>
                            <div class="mt-3">
                                <a href="{{ route('posts.show', $post) }}">Detail</a> /
                                <a href="{{ route('posts.edit', $post) }}">Edit</a> /
                                <form action="{{ route('posts.destroy', $post) }}" method="POST" class="d-inline">
                                    @csrf
                                    @method('DELETE')
                                    <button class="btn btn-link p-0 border-0 text-danger">Delete</button>
                                </form>
                            </div>
                        @endcomponent
                    @empty
                        <p>You have no posts yet. Create a new post <a href="{{ route('posts.create') }}">here</a>.</p>
                    @endforelse
                @endauth

                @guest
                    <p>Please login <a href="{{ route('login') }}">here</a>.</p>
                    <p>If you don't have an account, register <a href="{{ route('register') }}">here</a>.</p>
                @endguest
            </div>
        </div>
    </div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>Laravel Test</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    Laravel Test
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('posts.index') }}">All Posts</a>
                        </li>
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/posts/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <h3>Create a New Post</h3>
            <div class="card mt-3">
                <div class="card-body">
                    <form action="{{ route('posts.store') }}" method="POST">
                        @csrf
                        <input type="hidden" name="user_id" value="{{ auth()->id() }}">
                        <div class="form-group">
                            <label for="title">Title</label>
                            <input type="text" name="title" value="{{ old('title') }}" class="form-control" id="title" required>
                        </div>
                        <div class="form-group">
                            <label for="content">Content</label>
                            <textarea class="form-control" name="content" id="content" rows="3" required>{!! old('content') !!}</textarea>
                        </div>
                        <div class="form-group">
                            <label for="posted">Post Date</label>
                            <input type="datetime-local" name="posted_at" value="{!! old('posted_at') !!}" class="form-control" id="posted" required>
                        </div>
                        <div class="form-group form-check">
                            <input type="hidden" name="is_draft" value="0">
                            <input type="checkbox" name="is_draft" value="1" class="form-check-input" id="is_draft" checked>
                            <label class="form-check-label" for="is_draft">Draft</label>
                        </div>
                        <div class="form-group form-check">
                            <input type="checkbox" name="is_members_only" value="1" class="form-check-input" id="is_members_only">
                            <label class="form-check-label" for="is_members_only">Members Only</label>
                        </div>
                        <button type="submit" class="btn btn-primary">Save</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <h3>Edit Post</h3>
            <div class="card mt-3">
                <div class="card-body">
                    @if ($errors->any())
                        <div class="alert alert-danger">
                            <ul class="m-0">
                                @foreach ($errors->all() as $error)
                                    <li>{{ $error }}</li>
                                @endforeach
                            </ul>
                        </div>
                    @endif
                    <form method="POST" action="{{ route('posts.update', $post) }}">
                        @csrf
                        @method('PUT')
                        <div class="form-group">
                            <label for="title">Title</label>
                            <input type="text" name="title" value="{{ $post->title }}" class="form-control" id="title" required>
                        </div>
                        <div class="form-group">
                            <label for="content">Content</label>
                            <textarea class="form-control" name="content" id="content" rows="3" required>{!! $post->content !!}</textarea>
                        </div>
                        <div class="form-group">
                            <label for="posted">Post Date</label>
                            <input type="datetime-local" name="posted_at" value="{{ $post->input_posted_at }}" class="form-control" id="posted" required>
                        </div>
                        <div class="form-group form-check">
                            <input type="hidden" name="is_draft" value="0">
                            <input type="checkbox" name="is_draft" value="1" class="form-check-input" id="is_draft" @if($post->is_draft) checked @endif>
                            <label class="form-check-label" for="is_draft">Draft</label>
                        </div>
                        <div class="form-group form-check">
                            <input type="hidden" name="is_members_only" value="0">
                            <input type="checkbox" name="is_members_only" value="1" class="form-check-input" id="is_members_only" @if($post->is_members_only) checked @endif>
                            <label class="form-check-label" for="is_members_only">Members Only</label>
                        </div>
                        <button type="submit" class="btn btn-primary">Save</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/posts/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <h1 class="h3">All Posts</h1>
                @forelse ($posts as $post)
                    @component('posts.item', ['post' => $post])
                        <div class="d-flex justify-content-between">
                            <span>{{ $post->user->name }}</span>
                            <span>{{ $post->posted_date }}</span>
                        </div>
                    @endcomponent
                @empty
                    <div class="card-body">
                        No post at the moment
                    </div>
                @endforelse
                <div class="mt-5">
                    {{ $posts->links() }}
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/posts/item.blade.php
<div class="card mt-3">
    <div class="card-header">
        <a href="{{ route('posts.show', $post) }}">{{ $post->uppercase_title }}</a>
    </div>
    <div class="card-body">
        {{ $slot }}
    </div>
</div>

resources/views/posts/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <h3>Post Detail</h3>
                @component('posts.item', ['post' => $post])
                    <div class="d-flex justify-content-between">
                        <span>{{ $post->user->name }}</span>
                        <span>{{ $post->posted_date }}</span>
                    </div>
                    <hr>
                    <div>
                        {!! $post->content_with_break !!}
                    </div>
                @endcomponent
            </div>
        </div>
    </div>
@endsection